
clear
import excel "N:\reallocation\Data\PCEBridge_1997-2020_SUM.xlsx", firstrow sheet("2019") cellrange(A5:J294)

// We use spending without trade margins as we include trade industries
rename E spending

generate good = 1
replace good = 0 if NIPALine > 50

bysort CommodityCode: egen spend_good = total(spending) if good == 1
bysort CommodityCode: egen spend_serv = total(spending) if good == 0

egen tot_spend_good = max(spend_good), by(CommodityCode)
egen tot_spend_serv = max(spend_serv), by(CommodityCode)

replace tot_spend_good = 0 if missing(tot_spend_good)
replace tot_spend_serv = 0 if missing(tot_spend_serv)

gene tot_spend = tot_spend_good + tot_spend_serv

gen good_share = tot_spend_good/tot_spend

gen good_indicator = 0
replace good_indicator = 1 if good_share > 0.5

bysort CommodityCode: keep if _n==1

// Variables to merge with BEA industry file
rename CommodityCode BEACode
keep BEACode tot_spend_good tot_spend_serv

// Manually add data for the wholesale and retail trade (consumption data from BEA input output tables)
// We do this because the wholesale/retail margins in the PCE bridge do not split these out
drop if BEACode == "4A0"
input
"42" 615608 .
"441" 169781 .
"445" 250025 .
"452" 230902 .
"4A0" 874540 .
end

save tfile_goods_share.dta, replace